import { NavigationInstruction, Next } from "aurelia-router";

type BackHandlerOrEmptyFunction = () => void | boolean;

let backButtonHandler: BackHandlerOrEmptyFunction = () => {};

export class AuthorizeStep
{
	public run( navigationInstruction: NavigationInstruction, next: Next ): Promise<any>
	{
		if( !backButtonHandler() )
		{
			return next.cancel();
		}

		return next();
	}
}

export function onBackButton( handler: BackHandlerOrEmptyFunction )
{
	backButtonHandler = handler;
}